/*
 * This include file contains all the definitions needed to configure the
 * tinyproxy program. -rjkaes
 */

#ifndef _CONFIG_H
#define _CONFIG_H

/* Change these if you want */

/* Default log file */
#define DEFAULT_LOG  "/var/log/tinyproxy.log"
/* Default port tinyproxy listens on */
#define DEFAULT_PORT 8080
/* Default user to change to after */
#define DEFAULT_USER "nobody"
/*
 * Define this if you want no header forwarding except for headers expressly
 * permitted with -a
 */
#define ANON
/*
 * Define this if you want to have all requests sent to a particular machine.
 * This is useful if you have another proxy further upstream which you must
 * send your HTTP requests through.
 */
#undef UPSTREAM

#ifdef UPSTREAM
#define UPSTREAM_PROXY_NAME "name.of.upstream.machine"
#define UPSTREAM_PROXY_PORT 80
#endif

/*
 * Define this if you want to send a XTinyproxy header which contains the
 * IP address of the peer socket.
 */
#undef XTINYPROXY

/*
 * Define this if you want tinyproxy to use /proc/loadavg to determine
 * system load (Linux only, I think)
 */
#define USE_PROC

#ifndef USE_PROC
/*
 * Path to uptime to determin system load.  This path doesn't have to be
 * valid if DEFAULT_CUTOFFLOAD is 0
 */
#define UPTIME_PATH "/usr/bin/uptime"
#endif /* !USE_PROC */

/*
 * The default load at which tinyproxy will start refusing connections.
 * 0 == disabled by default
 */
#define DEFAULT_CUTOFFLOAD 0

/*
 * NOTE: for DEFAULT_STATHOST:  this controls remote proxy stats display.
 * for example, the default DEFAULT_STATHOST of "tinyproxy.stats" will
 * mean that when you use the proxy to access http://tinyproxy.stats/",
 * you will be shown the proxy stats.  Set this to something obscure
 * if you don't want random people to be able to see them, or set it to
 * "" to disable.  In the future, I figure maybe some sort of auth
 * might be desirable, but that would involve a major simplicity
 * sacrifice.
 */

/* The "hostname" for getting tinyproxy stats. "" = disabled by default */
#define DEFAULT_STATHOST "tinyproxy.stats"

/*
 * NOTE: change these if you know what you're doing
 */
#define SOCK_TIMEOUT 5
/* Recalculate load avery 30 seconds */
#define LOAD_RECALCTIMER 30
/* Default HTTP port */
#define HTTP_PORT 80
/* Once every 100 hits */
#define GARBCOLL_INTERVAL 100
/* Every time conncoll is called, nuke connections idle for > 60 seconds */
#define STALECONN_TIME 60

#endif
