/*
 * Definitions of all the global structures used in the program. - rjkaes
 */

#include "global.h"

/* 
 * Global Structures
 */
struct config_s config = {
	NULL,                      /* Log file handle */
	DEFAULT_LOG,               /* Logfile name */
	FALSE,                     /* Use syslog instead? */
	DEFAULT_CUTOFFLOAD,        /* Cut off load */
	DEFAULT_PORT,              /* Listen on this port */
	DEFAULT_STATHOST,          /* URL of stats host */
	FALSE,                     /* Quit? */
	DEFAULT_USER,              /* Name of user to change to */
	FALSE                      /* Run anonymous by default? */
};

struct conn_s connections = {
	0,                         /* File descriptor */ 
	NULL,                      /* Host address */
	0,                         /* Port */
	NULL,                      /* The request */
	PLACEHOLDER,               /* Connection type */
	FALSE,                     /* Kill me? */
#ifdef ANON
	FALSE,                     /* Post header */
#endif
	NULL,                      /* Next connection */
	NULL,                      /* Previous connection */
	NULL,                      /* Other half of connection */
	0,                         /* Initial time */
	0,                         /* Time action took */
	0,                         /* Size of buffer */
	NULL,                      /* Buffer for connection */
};

struct stat_s stats = {
	0,                         /* Requests */
	0,                         /* Connections */
	0,                         /* Bad connections */
	0,                         /* Opened */
	0,                         /* Listened to */
	0,                         /* Bytes sent */
	0,                         /* Bytes received */
	0,                         /* Connection garbage collected */
	0,                         /* Idle connections */
	0                          /* Refused */
};

float load = 0.00;

#ifdef ANON
struct allowedhdr_s *allowedhdrs = NULL;
#endif

int tinyerr;
