/*
 * Declarations for all the global structures, plus a few other defines needed
 * throughout the rest of the program. I'm not completely happy with this
 * layout, but it's the best I have at the moment. - rjkaes
 */
#ifndef _GLOBAL_H
#define _GLOBAL_H

#include <stdio.h>
#include <time.h>

#include "config.h"

/* Global variables for the main controls of the program */
#define VERSION	  "tinyproxy 1.2.7"	/* Version Number of the program */
#define BUFFER 	  4096			/* Size of buffer for reading */
#define MAXLISTEN 128			/* Max number of connections to listen for */

/* Make a new type: flag */
typedef char flag;

/* Different connection types */
enum conn_type { CLIENTCONN, CONNECTINGCONN, SERVERCONN, PLACEHOLDER, IGNORECONN };

/* Other stuff */
#define FALSE (0)
#define TRUE  (!FALSE)

struct config_s {
	FILE *logf;
	char *logf_name;
	flag syslog;
	float cutoffload;
	int port;
	char *stathost;
	flag quit;
	char *changeuser;
	flag anonymous;
};

struct stat_s {
	int num_reqs;
	int num_cons;
	int num_badcons;
	int num_opens;
	int num_listens;
	int num_tx;
	int num_rx;
	int num_garbage;
	int num_idles;
	int num_refused;
};

struct conn_s {
	int fd;
	char *host;
	int port;
	char *request;
	enum conn_type conntype;
	flag killme;
#ifdef ANON
	flag postheader;
#endif
	struct conn_s *next, *prev, *other;
	time_t inittime, actiontime;
	int buffsize;
	unsigned char *buffer;
};

#ifdef ANON
struct allowedhdr_s {
	char *hdrname;
	struct allowedhdr_s *next;
};
#endif

/* Global Structures used in the program */
extern struct conn_s connections;
extern struct config_s config;
extern struct stat_s stats;
#ifdef ANON
extern struct allowedhdr_s *allowedhdrs;
#endif
extern float load;

#endif
