/*
 * log.c - For the manipulation of log files.
 */
#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <syslog.h>
#include <stdlib.h>

#include "global.h"
#include "log.h"

/*
 * This routine logs messages to either the log file or the syslog function.
 */
void log(char *fmt,...)
{
	va_list args;
	time_t nowtime;
	char *p;
	FILE *cf;
	static char str[800];

	va_start(args, fmt);
	if (config.syslog == FALSE) {
		nowtime = time(NULL);
		p = ctime(&nowtime);
		p[strlen(p) - 1] = '\0';
      
		if (!(cf = config.logf))
			cf = stderr;
      
		fprintf(cf, "%s: ", p);
		vfprintf(cf, fmt, args);
		fprintf(cf, "\n");
		fflush(cf);
	} else {
		vsnprintf(str, 800, fmt, args);
		syslog(LOG_INFO, str);
	}

	va_end(args);
}
